/[gentoo-x86]/eclass/apache-2.eclass
Gentoo

Diff of /eclass/apache-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.4 Revision 1.18
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/apache-2.eclass,v 1.4 2007/12/20 15:53:19 zmedico Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/apache-2.eclass,v 1.18 2009/09/20 08:37:23 hollow Exp $
4 4
5EAPI="2"
6
5# @ECLASS: apache-2 7# @ECLASS: apache-2.eclass
8# @MAINTAINER:
6# @MAINTAINER: apache-devs@gentoo.org 9# apache-devs@gentoo.org
7# @BLURB: Provides a common set of functions for >=apache-2.2* ebuilds 10# @BLURB: Provides a common set of functions for apache-2.x ebuilds
8# @DESCRIPTION: 11# @DESCRIPTION:
9# This eclass handles common apache ebuild functions in a sane way and providing 12# This eclass handles apache-2.x ebuild functions such as LoadModule generation
10# information about where certain interfaces are located such as LoadModule
11# generation and inter-module dependency checking. 13# and inter-module dependency checking.
12 14
13inherit depend.apache eutils flag-o-matic multilib autotools 15inherit autotools eutils flag-o-matic multilib ssl-cert
14 16
15# ============================================================================== 17# ==============================================================================
16# INTERNAL VARIABLES 18# INTERNAL VARIABLES
17# ============================================================================== 19# ==============================================================================
18 20
19# @ECLASS-VARIABLE: GENTOO_PATCHNAME 21# @ECLASS-VARIABLE: GENTOO_PATCHNAME
20# @DESCRIPTION: 22# @DESCRIPTION:
21# This internal variable contains the prefix for the patch tarball 23# This internal variable contains the prefix for the patch tarball.
22GENTOO_PATCHNAME="gentoo-${PF}" 24# Defaults to the full name and version (including revision) of the package.
25# If you want to override this in an ebuild, use:
26# ORIG_PR="(revision of Gentoo stuff you want)"
27# GENTOO_PATCHNAME="gentoo-${PN}-${PV}${ORIG_PR:+-${ORIG_PR}}"
28[[ -n "$GENTOO_PATCHNAME" ]] || GENTOO_PATCHNAME="gentoo-${PF}"
23 29
24# @ECLASS-VARIABLE: GENTOO_PATCHDIR 30# @ECLASS-VARIABLE: GENTOO_PATCHDIR
25# @DESCRIPTION: 31# @DESCRIPTION:
26# This internal variable contains the working directory where patches and config 32# This internal variable contains the working directory where patches and config
27# files are located 33# files are located.
34# Defaults to the patchset name appended to the working directory.
28GENTOO_PATCHDIR="${WORKDIR}/${GENTOO_PATCHNAME}" 35[[ -n "$GENTOO_PATCHDIR" ]] || GENTOO_PATCHDIR="${WORKDIR}/${GENTOO_PATCHNAME}"
29 36
30# @ECLASS-VARIABLE: GENTOO_DEVELOPER 37# @VARIABLE: GENTOO_DEVELOPER
31# @DESCRIPTION: 38# @DESCRIPTION:
32# This variable needs to be set in the ebuild and contains the name of the 39# This variable needs to be set in the ebuild and contains the name of the
33# gentoo developer who created the patch tarball 40# gentoo developer who created the patch tarball
34 41
35# @ECLASS-VARIABLE: GENTOO_PATCHSTAMP 42# @VARIABLE: GENTOO_PATCHSTAMP
36# @DESCRIPTION: 43# @DESCRIPTION:
37# This variable needs to be set in the ebuild and contains the date the patch 44# This variable needs to be set in the ebuild and contains the date the patch
38# tarball was created at in YYMMDD format 45# tarball was created at in YYYYMMDD format
46
47# @VARIABLE: GENTOO_PATCH_A
48# @DESCRIPTION:
49# This variable should contain the entire filename of patch tarball.
50# Defaults to the name of the patchset, with a datestamp.
51[[ -n "$GENTOO_PATCH_A" ]] || GENTOO_PATCH_A="${GENTOO_PATCHNAME}-${GENTOO_PATCHSTAMP}.tar.bz2"
39 52
40SRC_URI="mirror://apache/httpd/httpd-${PV}.tar.bz2 53SRC_URI="mirror://apache/httpd/httpd-${PV}.tar.bz2
41 http://dev.gentoo.org/~${GENTOO_DEVELOPER}/dist/apache/${GENTOO_PATCHNAME}-${GENTOO_PATCHSTAMP}.tar.bz2" 54 http://dev.gentoo.org/~${GENTOO_DEVELOPER}/dist/apache/${GENTOO_PATCH_A}"
42 55
43# @ECLASS-VARIABLE: IUSE_MPMS_FORK 56# @VARIABLE: IUSE_MPMS_FORK
44# @DESCRIPTION: 57# @DESCRIPTION:
45# This variable needs to be set in the ebuild and contains a list of forking 58# This variable needs to be set in the ebuild and contains a list of forking
46# (i.e. non-threaded) MPMS 59# (i.e. non-threaded) MPMs
47 60
48# @ECLASS-VARIABLE: IUSE_MPMS_THREAD 61# @VARIABLE: IUSE_MPMS_THREAD
49# @DESCRIPTION: 62# @DESCRIPTION:
50# This variable needs to be set in the ebuild and contains a list of threaded 63# This variable needs to be set in the ebuild and contains a list of threaded
51# MPMS 64# MPMs
52 65
53# @ECLASS-VARIABLE: IUSE_MODULES 66# @VARIABLE: IUSE_MODULES
54# @DESCRIPTION: 67# @DESCRIPTION:
55# This variable needs to be set in the ebuild and contains a list of available 68# This variable needs to be set in the ebuild and contains a list of available
56# built-in modules 69# built-in modules
57 70
58IUSE_MPMS="${IUSE_MPMS_FORK} ${IUSE_MPMS_THREAD}" 71IUSE_MPMS="${IUSE_MPMS_FORK} ${IUSE_MPMS_THREAD}"
66 IUSE="${IUSE} apache2_mpms_${mpm}" 79 IUSE="${IUSE} apache2_mpms_${mpm}"
67done 80done
68 81
69DEPEND="dev-lang/perl 82DEPEND="dev-lang/perl
70 =dev-libs/apr-1* 83 =dev-libs/apr-1*
71 =dev-libs/apr-util-1* 84 =dev-libs/apr-util-1*[ldap?]
72 dev-libs/libpcre 85 dev-libs/libpcre
73 ldap? ( =net-nds/openldap-2* ) 86 ldap? ( =net-nds/openldap-2* )
74 selinux? ( sec-policy/selinux-apache ) 87 selinux? ( sec-policy/selinux-apache )
75 ssl? ( dev-libs/openssl ) 88 ssl? ( >=dev-libs/openssl-0.9.8f )
76 !=www-servers/apache-1*" 89 !=www-servers/apache-1*"
77RDEPEND="${DEPEND}" 90RDEPEND="${DEPEND}"
78PDEPEND="~app-admin/apache-tools-${PV}" 91PDEPEND="~app-admin/apache-tools-${PV}"
79 92
80S="${WORKDIR}/httpd-${PV}" 93S="${WORKDIR}/httpd-${PV}"
82# ============================================================================== 95# ==============================================================================
83# INTERNAL FUNCTIONS 96# INTERNAL FUNCTIONS
84# ============================================================================== 97# ==============================================================================
85 98
86# @ECLASS-VARIABLE: MY_MPM 99# @ECLASS-VARIABLE: MY_MPM
87# DESCRIPTION: 100# @DESCRIPTION:
88# This internal variable contains the selected MPM after a call to setup_mpm() 101# This internal variable contains the selected MPM after a call to setup_mpm()
89 102
90# @FUNCTION: setup_mpm 103# @FUNCTION: setup_mpm
91# @DESCRIPTION: 104# @DESCRIPTION:
92# This internal function makes sure that only one of APACHE2_MPMS was selected 105# This internal function makes sure that only one of APACHE2_MPMS was selected
131 eerror "You have selected a non-threaded MPM but USE=threads is enabled" 144 eerror "You have selected a non-threaded MPM but USE=threads is enabled"
132 die "invalid use flag combination" 145 die "invalid use flag combination"
133 fi 146 fi
134} 147}
135 148
136# @ECLASS-VARIABLE: MODULE_CRITICAL 149# @VARIABLE: MODULE_CRITICAL
137# @DESCRIPTION: 150# @DESCRIPTION:
138# This variable needs to be set in the ebuild and contains a space-separated 151# This variable needs to be set in the ebuild and contains a space-separated
139# list of modules critical for the default apache. A user may still 152# list of modules critical for the default apache. A user may still
140# disable these modules for custom minimal installation at their own risk. 153# disable these modules for custom minimal installation at their own risk.
141 154
162 ewarn 175 ewarn
163 ebeep 10 176 ebeep 10
164 fi 177 fi
165} 178}
166 179
167# @ECLASS-VARIABLE: MODULE_DEPENDS 180# @VARIABLE: MODULE_DEPENDS
168# @DESCRIPTION: 181# @DESCRIPTION:
169# This variable needs to be set in the ebuild and contains a space-separated 182# This variable needs to be set in the ebuild and contains a space-separated
170# list of dependency tokens each with a module and the module it depends on 183# list of dependency tokens each with a module and the module it depends on
171# separated by a colon 184# separated by a colon
172 185
177check_module_depends() { 190check_module_depends() {
178 local err=0 191 local err=0
179 192
180 for m in ${MY_MODS} ; do 193 for m in ${MY_MODS} ; do
181 for dep in ${MODULE_DEPENDS} ; do 194 for dep in ${MODULE_DEPENDS} ; do
182 if [[ "${m}" == "${dep%:*}" ]]; then 195 if [[ "${m}" == "${dep%:*}" ]] ; then
183 if ! use apache2_modules_${dep#*:} ; then 196 if ! use apache2_modules_${dep#*:} ; then
184 eerror "Module '${m}' depends on '${dep#*:}'" 197 eerror "Module '${m}' depends on '${dep#*:}'"
185 err=1 198 err=1
186 fi 199 fi
187 fi 200 fi
192 die "invalid use flag combination" 205 die "invalid use flag combination"
193 fi 206 fi
194} 207}
195 208
196# @ECLASS-VARIABLE: MY_CONF 209# @ECLASS-VARIABLE: MY_CONF
197# DESCRIPTION: 210# @DESCRIPTION:
198# This internal variable contains the econf options for the current module 211# This internal variable contains the econf options for the current module
199# selection after a call to setup_modules() 212# selection after a call to setup_modules()
200 213
201# @ECLASS-VARIABLE: MY_MODS 214# @ECLASS-VARIABLE: MY_MODS
202# DESCRIPTION: 215# @DESCRIPTION:
203# This internal variable contains a sorted, space separated list of currently 216# This internal variable contains a sorted, space separated list of currently
204# selected modules after a call to setup_modules() 217# selected modules after a call to setup_modules()
205 218
206# @FUNCTION: setup_modules 219# @FUNCTION: setup_modules
207# @DESCRIPTION: 220# @DESCRIPTION:
217 fi 230 fi
218 231
219 MY_CONF="--enable-so=static" 232 MY_CONF="--enable-so=static"
220 233
221 if use ldap ; then 234 if use ldap ; then
222 if ! built_with_use 'dev-libs/apr-util' ldap ; then
223 eerror "dev-libs/apr-util is missing LDAP support. For apache to have"
224 eerror "ldap support, apr-util must be built with the ldap USE-flag"
225 eerror "enabled."
226 die "ldap USE-flag enabled while not supported in apr-util"
227 fi
228 MY_CONF="${MY_CONF} --enable-authnz_ldap=${mod_type} --enable-ldap=${mod_type}" 235 MY_CONF="${MY_CONF} --enable-authnz_ldap=${mod_type} --enable-ldap=${mod_type}"
229 MY_MODS="${MY_MODS} ldap authnz_ldap" 236 MY_MODS="${MY_MODS} ldap authnz_ldap"
230 else 237 else
231 MY_CONF="${MY_CONF} --disable-authnz_ldap --disable-ldap" 238 MY_CONF="${MY_CONF} --disable-authnz_ldap --disable-ldap"
232 fi 239 fi
288 MY_MODS=$(echo ${MY_MODS} | tr ' ' '\n' | sort -u) 295 MY_MODS=$(echo ${MY_MODS} | tr ' ' '\n' | sort -u)
289 check_module_depends 296 check_module_depends
290 check_module_critical 297 check_module_critical
291} 298}
292 299
293# @ECLASS-VARIABLE: MODULE_DEFINES 300# @VARIABLE: MODULE_DEFINES
294# @DESCRIPTION: 301# @DESCRIPTION:
295# This variable needs to be set in the ebuild and contains a space-separated 302# This variable needs to be set in the ebuild and contains a space-separated
296# list of tokens each mapping a module to a runtime define which can be 303# list of tokens each mapping a module to a runtime define which can be
297# specified in APACHE2_OPTS in /etc/conf.d/apache2 to enable this particular 304# specified in APACHE2_OPTS in /etc/conf.d/apache2 to enable this particular
298# module. 305# module.
300# @FUNCTION: generate_load_module 307# @FUNCTION: generate_load_module
301# @DESCRIPTION: 308# @DESCRIPTION:
302# This internal function generates the LoadModule lines for httpd.conf based on 309# This internal function generates the LoadModule lines for httpd.conf based on
303# the current module selection and MODULE_DEFINES 310# the current module selection and MODULE_DEFINES
304generate_load_module() { 311generate_load_module() {
305 local endit=0 mod_lines= mod_dir="${D}${APACHE2_MODULESDIR}" 312 local endit=0 mod_lines= mod_dir="${D}/usr/$(get_libdir)/apache2/modules"
306 313
307 if use static; then 314 if use static; then
308 sed -i -e "/%%LOAD_MODULE%%/d" \ 315 sed -i -e "/%%LOAD_MODULE%%/d" \
309 "${GENTOO_PATCHDIR}"/conf/httpd.conf 316 "${GENTOO_PATCHDIR}"/conf/httpd.conf
310 return 317 return
362# creates the apache user and group and informs about CONFIG_SYSVIPC being 369# creates the apache user and group and informs about CONFIG_SYSVIPC being
363# needed (we don't depend on kernel sources and therefore cannot check). 370# needed (we don't depend on kernel sources and therefore cannot check).
364apache-2_pkg_setup() { 371apache-2_pkg_setup() {
365 check_upgrade 372 check_upgrade
366 373
367 setup_mpm
368 setup_modules
369
370 if use debug; then
371 MY_CONF="${MY_CONF} --enable-maintainer-mode --enable-exception-hook"
372 fi
373
374 # setup apache user and group 374 # setup apache user and group
375 enewgroup apache 81 375 enewgroup apache 81
376 enewuser apache 81 -1 /var/www apache 376 enewuser apache 81 -1 /var/www apache
377 377
378 setup_mpm
379 setup_modules
380
381 if use debug; then
382 MY_CONF="${MY_CONF} --enable-maintainer-mode --enable-exception-hook"
383 fi
384
378 elog "Please note that you need SysV IPC support in your kernel." 385 elog "Please note that you need SysV IPC support in your kernel."
379 elog "Make sure CONFIG_SYSVIPC=y is set." 386 elog "Make sure CONFIG_SYSVIPC=y is set."
380 elog 387 elog
381}
382 388
389 if use userland_BSD; then
390 elog "On BSD systems you need to add the following line to /boot/loader.conf:"
391 elog " accf_http_load=\"YES\""
392 elog
393 fi
394}
395
383# @FUNCTION: apache-2_src_unpack 396# @FUNCTION: apache-2_src_prepare
384# @DESCRIPTION: 397# @DESCRIPTION:
385# This function applies patches, configures a custom file-system layout and 398# This function applies patches, configures a custom file-system layout and
386# rebuilds the configure scripts. 399# rebuilds the configure scripts.
387apache-2_src_unpack() { 400apache-2_src_prepare() {
388 unpack ${A} 401 # 03_all_gentoo-apache-tools.patch injects -Wl,-z,now, which is not a good
389 cd "${S}" 402 # idea for everyone
403 case ${CHOST} in
404 *-linux-gnu|*-solaris*|*-freebsd*)
405 # do nothing, these use GNU binutils
406 :
407 ;;
408 *-darwin*)
409 sed -i -e 's/-Wl,-z,now/-Wl,-bind_at_load/g' \
410 "${GENTOO_PATCHDIR}"/patches/03_all_gentoo_apache-tools.patch
411 ;;
412 *)
413 # patch it out to be like upstream
414 sed -i -e 's/-Wl,-z,now//g' \
415 "${GENTOO_PATCHDIR}"/patches/03_all_gentoo_apache-tools.patch
416 ;;
417 esac
390 418
391 # Use correct multilib libdir in gentoo patches 419 # Use correct multilib libdir in gentoo patches
392 sed -i -e "s:/usr/lib:/usr/$(get_libdir):g" \ 420 sed -i -e "s:/usr/lib:/usr/$(get_libdir):g" \
393 "${GENTOO_PATCHDIR}"/{conf/httpd.conf,init/*,patches/config.layout} \ 421 "${GENTOO_PATCHDIR}"/{conf/httpd.conf,init/*,patches/config.layout} \
394 || die "libdir sed failed" 422 || die "libdir sed failed"
407 # patched-in MPMs need the build environment rebuilt 435 # patched-in MPMs need the build environment rebuilt
408 sed -i -e '/sinclude/d' configure.in 436 sed -i -e '/sinclude/d' configure.in
409 AT_GNUCONF_UPDATE=yes AT_M4DIR=build eautoreconf 437 AT_GNUCONF_UPDATE=yes AT_M4DIR=build eautoreconf
410} 438}
411 439
412# @FUNCTION: apache-2_src_compile 440# @FUNCTION: apache-2_src_configure
413# @DESCRIPTION: 441# @DESCRIPTION:
414# This function adds compiler flags and runs econf and emake based on MY_MPM and 442# This function adds compiler flags and runs econf and emake based on MY_MPM and
415# MY_CONF 443# MY_CONF
416apache-2_src_compile() { 444apache-2_src_configure() {
417 # Instead of filtering --as-needed (bug #128505), append --no-as-needed 445 # Instead of filtering --as-needed (bug #128505), append --no-as-needed
418 # Thanks to Harald van Dijk 446 # Thanks to Harald van Dijk
447 # ... but only on platforms that use a GNU linker!
448 case ${CHOST} in
449 *-solaris* | *-*bsd* | *-linux-gnu)
419 append-ldflags -Wl,--no-as-needed 450 append-ldflags -Wl,--no-as-needed
451 ;;
452 esac
420 453
421 # peruser MPM debugging with -X is nearly impossible 454 # peruser MPM debugging with -X is nearly impossible
422 if has peruser ${IUSE_MPMS} && use apache2_mpms_peruser ; then 455 if has peruser ${IUSE_MPMS} && use apache2_mpms_peruser ; then
423 use debug && append-flags -DMPM_PERUSER_DEBUG 456 use debug && append-flags -DMPM_PERUSER_DEBUG
424 fi 457 fi
430 --libexecdir=/usr/$(get_libdir)/apache2/modules \ 463 --libexecdir=/usr/$(get_libdir)/apache2/modules \
431 --datadir=/var/www/localhost \ 464 --datadir=/var/www/localhost \
432 --sysconfdir=/etc/apache2 \ 465 --sysconfdir=/etc/apache2 \
433 --localstatedir=/var \ 466 --localstatedir=/var \
434 --with-mpm=${MY_MPM} \ 467 --with-mpm=${MY_MPM} \
435 --with-perl=/usr/bin/perl \
436 --with-apr=/usr \ 468 --with-apr=/usr \
437 --with-apr-util=/usr \ 469 --with-apr-util=/usr \
438 --with-pcre=/usr \ 470 --with-pcre=/usr \
439 --with-z=/usr \ 471 --with-z=/usr \
440 --with-port=80 \ 472 --with-port=80 \
441 --with-program-name=apache2 \ 473 --with-program-name=apache2 \
442 --enable-layout=Gentoo \ 474 --enable-layout=Gentoo \
443 ${MY_CONF} || die "econf failed!" 475 ${MY_CONF} || die "econf failed!"
444 476
445 sed -i -e 's:apache2\.conf:httpd.conf:' include/ap_config_auto.h 477 sed -i -e 's:apache2\.conf:httpd.conf:' include/ap_config_auto.h
446
447 emake || die "emake failed"
448} 478}
449 479
450# @FUNCTION: apache-2_src_install 480# @FUNCTION: apache-2_src_install
451# @DESCRIPTION: 481# @DESCRIPTION:
452# This function runs emake install and generates, install and adapts the gentoo 482# This function runs `emake install' and generates, installs and adapts the gentoo
453# specific configuration files found in the tarball 483# specific configuration files found in the tarball
454apache-2_src_install() { 484apache-2_src_install() {
455 emake DESTDIR="${D}" install || die "emake install failed" 485 make DESTDIR="${D}" install || die "make install failed"
456 486
457 # install our configuration files 487 # install our configuration files
458 keepdir /etc/apache2/vhosts.d 488 keepdir /etc/apache2/vhosts.d
459 keepdir /etc/apache2/modules.d 489 keepdir /etc/apache2/modules.d
460 490
465 495
466 insinto /etc/logrotate.d 496 insinto /etc/logrotate.d
467 newins "${GENTOO_PATCHDIR}"/scripts/apache2-logrotate apache2 497 newins "${GENTOO_PATCHDIR}"/scripts/apache2-logrotate apache2
468 498
469 # generate a sane default APACHE2_OPTS 499 # generate a sane default APACHE2_OPTS
470 APACHE2_OPTS="-D DEFAULT_VHOST -D INFO -D LANGUAGE" 500 APACHE2_OPTS="-D DEFAULT_VHOST -D INFO"
471 use doc && APACHE2_OPTS="${APACHE2_OPTS} -D MANUAL" 501 use doc && APACHE2_OPTS="${APACHE2_OPTS} -D MANUAL"
472 use ssl && APACHE2_OPTS="${APACHE2_OPTS} -D SSL -D SSL_DEFAULT_VHOST" 502 use ssl && APACHE2_OPTS="${APACHE2_OPTS} -D SSL -D SSL_DEFAULT_VHOST"
473 use suexec && APACHE2_OPTS="${APACHE2_OPTS} -D SUEXEC" 503 use suexec && APACHE2_OPTS="${APACHE2_OPTS} -D SUEXEC"
504 if hasq negotiation ${APACHE2_MODULES} && use apache2_modules_negotiation; then
505 APACHE2_OPTS="${APACHE2_OPTS} -D LANGUAGE"
506 fi
474 507
475 sed -i -e "s:APACHE2_OPTS=\".*\":APACHE2_OPTS=\"${APACHE2_OPTS}\":" \ 508 sed -i -e "s:APACHE2_OPTS=\".*\":APACHE2_OPTS=\"${APACHE2_OPTS}\":" \
476 "${GENTOO_PATCHDIR}"/init/apache2.confd || die "sed failed" 509 "${GENTOO_PATCHDIR}"/init/apache2.confd || die "sed failed"
477 510
478 newconfd "${GENTOO_PATCHDIR}"/init/apache2.confd apache2 511 newconfd "${GENTOO_PATCHDIR}"/init/apache2.confd apache2
479 newinitd "${GENTOO_PATCHDIR}"/init/apache2.initd apache2 512 newinitd "${GENTOO_PATCHDIR}"/init/apache2.initd apache2
480 513
481 # link apache2ctl to the init script 514 # install apache2ctl wrapper for our init script if available
515 if test -e "${GENTOO_PATCHDIR}"/scripts/apache2ctl; then
516 exeinto /usr/sbin
517 doexe "${GENTOO_PATCHDIR}"/scripts/apache2ctl
518 else
482 dosym /etc/init.d/apache2 /usr/sbin/apache2ctl 519 dosym /etc/init.d/apache2 /usr/sbin/apache2ctl
520 fi
483 521
484 # provide symlinks for all the stuff we no longer rename, bug 177697 522 # provide legacy symlink for apxs, bug 177697
485 for i in suexec apxs; do
486 dosym /usr/sbin/${i} /usr/sbin/${i}2 523 dosym /usr/sbin/apxs /usr/sbin/apxs2
487 done
488
489 # install some thirdparty scripts
490 exeinto /usr/sbin
491 use ssl && doexe "${GENTOO_PATCHDIR}"/scripts/gentestcrt.sh
492 524
493 # install some documentation 525 # install some documentation
494 dodoc ABOUT_APACHE CHANGES LAYOUT README README.platforms VERSIONING 526 dodoc ABOUT_APACHE CHANGES LAYOUT README README.platforms VERSIONING
495 dodoc "${GENTOO_PATCHDIR}"/docs/* 527 dodoc "${GENTOO_PATCHDIR}"/docs/*
496 528
500 else 532 else
501 rm -f "${D}/etc/apache2/modules.d/00_apache_manual.conf" 533 rm -f "${D}/etc/apache2/modules.d/00_apache_manual.conf"
502 rm -Rf "${D}/usr/share/doc/${PF}/manual" 534 rm -Rf "${D}/usr/share/doc/${PF}/manual"
503 fi 535 fi
504 536
505 # the default webroot gets stored in /usr/share/doc 537 # the default icons and error pages get stored in
506 ebegin "Installing default webroot to /usr/share/doc/${PF}" 538 # /usr/share/apache2/{error,icons}
539 dodir /usr/share/apache2
507 mv -f "${D}/var/www/localhost" "${D}/usr/share/doc/${PF}/webroot" 540 mv -f "${D}/var/www/localhost/error" "${D}/usr/share/apache2/error"
541 mv -f "${D}/var/www/localhost/icons" "${D}/usr/share/apache2/icons"
542 rm -rf "${D}/var/www/localhost/"
508 eend $? 543 eend $?
509 keepdir /var/www/localhost/htdocs
510 544
511 # set some sane permissions for suexec 545 # set some sane permissions for suexec
512 if use suexec ; then 546 if use suexec ; then
513 fowners 0:apache /usr/sbin/suexec 547 fowners 0:${SUEXEC_CALLER:-apache} /usr/sbin/suexec
514 fperms 4710 /usr/sbin/suexec 548 fperms 4710 /usr/sbin/suexec
549 # provide legacy symlink for suexec, bug 177697
550 dosym /usr/sbin/suexec /usr/sbin/suexec2
515 fi 551 fi
516 552
517 # empty dirs 553 # empty dirs
518 for i in /var/lib/dav /var/log/apache2 /var/cache/apache2 ; do 554 for i in /var/lib/dav /var/log/apache2 /var/cache/apache2 ; do
519 keepdir ${i} 555 keepdir ${i}
520 fowners apache:apache ${i} 556 fowners apache:apache ${i}
521 fperms 0755 ${i} 557 fperms 0755 ${i}
522 done 558 done
523
524 # we need /etc/apache2/ssl if USE=ssl
525 use ssl && keepdir /etc/apache2/ssl
526} 559}
527 560
528# @FUNCTION: apache-2_pkg_postinst 561# @FUNCTION: apache-2_pkg_postinst
529# @DESCRIPTION: 562# @DESCRIPTION:
530# This function creates test certificates if SSL is enabled and installs the 563# This function creates test certificates if SSL is enabled and installs the
531# default webroot if /var/www/localhost does not exist. We do this here because 564# default index.html to /var/www/localhost if it does not exist. We do this here
532# the default webroot is a copy of the files that exist elsewhere and we don't 565# because the default webroot is a copy of the files that exist elsewhere and we
533# want them to be managed/removed by portage when apache is upgraded. 566# don't want them to be managed/removed by portage when apache is upgraded.
534apache-2_pkg_postinst() { 567apache-2_pkg_postinst() {
535 if use ssl && [[ ! -e "${ROOT}/etc/apache2/ssl/server.crt" ]] ; then 568 if use ssl && [[ ! -e "${ROOT}/etc/ssl/apache2/server.pem" ]]; then
536 cd "${ROOT}"/etc/apache2/ssl 569 SSL_ORGANIZATION="${SSL_ORGANIZATION:-Apache HTTP Server}"
537 einfo 570 install_cert /etc/ssl/apache2/server
538 einfo "Generating self-signed test certificate in ${ROOT}etc/apache2/ssl ..." 571 ewarn
539 yes "" 2>/dev/null | \ 572 ewarn "The location of SSL certificates has changed. If you are"
540 "${ROOT}"/usr/sbin/gentestcrt.sh >/dev/null 2>&1 || \ 573 ewarn "upgrading from ${CATEGORY}/${PN}-2.2.13 or earlier (or remerged"
541 die "gentestcrt.sh failed" 574 ewarn "*any* apache version), you might want to move your old"
542 einfo 575 ewarn "certificates from /etc/apache2/ssl/ to /etc/ssl/apache2/ and"
576 ewarn "update your config files."
577 ewarn
543 fi 578 fi
544 579
545 if [[ -e "${ROOT}/var/www/localhost" ]] ; then 580 if [[ ! -e "${ROOT}/var/www/localhost" ]] ; then
546 elog "The default webroot has not been installed into"
547 elog "${ROOT}var/www/localhost because the directory already exists"
548 elog "and we do not want to overwrite any files you have put there."
549 elog
550 elog "If you would like to install the latest webroot, please run"
551 elog "emerge --config =${PF}"
552 elog
553 else
554 einfo "Installing default webroot to ${ROOT}var/www/localhost"
555 mkdir -p "${ROOT}"/var/www/localhost 581 mkdir -p "${ROOT}/var/www/localhost/htdocs"
556 cp -R "${ROOT}"/usr/share/doc/${PF}/webroot/* "${ROOT}"/var/www/localhost 582 echo "<html><body><h1>It works!</h1></body></html>" > "${ROOT}/var/www/localhost/htdocs/index.html"
557 chown -R apache:0 "${ROOT}"/var/www/localhost
558 fi 583 fi
559} 584}
560 585
561# @FUNCTION: apache-2_pkg_config
562# @DESCRIPTION:
563# This function installs -- and removes a previously existing -- default webroot
564# to /var/www/localhost
565apache-2_pkg_config() {
566 einfo "Installing default webroot to ${ROOT}var/www/localhost"
567 mkdir "${ROOT}"var{,/www{,/localhost}}
568 cp -R "${ROOT}"usr/share/doc/${PF}/webroot/* "${ROOT}"var/www/localhost/
569}
570
571EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_config 586EXPORT_FUNCTIONS pkg_setup src_prepare src_configure src_install pkg_postinst

Legend:
Removed from v.1.4  
changed lines
  Added in v.1.18

  ViewVC Help
Powered by ViewVC 1.1.20